/***************************************************************************

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

***************************************************************************/

#include <qobject.h>

#include "misc.h"

class Waiting : public QObject
{
	Q_OBJECT
	
public:
	Waiting();
	~Waiting();

private:
	int PosInMenu;			// pozycja, na jakiej znajdzie si wpis w menu kontekstowym;
	UinsList Tracked, AlwaysTracked;// lista osb, ktre sprawdzamy + lista na ktre zawsze czekamy
	int OurUin;			// przechowuje nasz uin
	bool UseSounds, RepeatSounds, AgainSound;
	QString SoundPath;
	int TimeBetweenSounds;

	
	void createGUI(void);
	void destroyGUI(void);
	
	void showMessage(const UserListElement &user, QString message, bool);

/**
	TRACKED LIST
**/
	bool isOnTrackedList(UinType uin);
	void removeFromTrackedList(const UserListElement &user);
	void addToTrackedList(const UserListElement &user);
	void loadTrackedList(void);
	void saveTrackedList(void);


/**
	ALWAYS TRACKED
**/
	bool isAlwaysTracked(UinType uin);	
	void loadAlwaysTrackedList(void);	
	void saveAlwaysTrackedList(void);
	
private slots:
/**
	wywoywane w momencie nacinicia naszej pozycji w menu kontekstowym - checkbox, czy czekamy na uin.
**/
	void wait4Person(void);
/**
	uruchamia si si, przy wywietlaniu menu kontekstowego przy licie kontaktw.
**/
	void popupMenu(void);
/**
	wywoywane jak jaki uin zmieni status - sprawdza, czy to nie jest ten, na ktrego czekamy...
**/
	void userStatusChanged(const UserListElement &, const UserStatus &oldStatus);
	void userStatusChanged_notify(const UserListElement &, const UserStatus &oldStatus);
	
	void checkOnConnection(void);
	
	void stopPlaingSound(void);
	void repeatSound(void);
	
	
/**
	GUI
**/
	void _Left(void);
	void _Right(void);
	void onCreateConfigDialog(void);
	void onApplyConfigDialog(void);
	void changeUseSounds(void);
	void changeRepeatSounds(void);
	void chooseSoundFile(void);
};
